
JSB.newAddon = function (mainPath) {
  JSB.require('webviewController');
    // NSUserDefaults.standardUserDefaults().removeObjectForKey("MNBrowser_entrieNames")
    // NSUserDefaults.standardUserDefaults().removeObjectForKey("MNBrowser_entries")
    // NSUserDefaults.standardUserDefaults().removeObjectForKey('MNBrowser_engine');
    // NSUserDefaults.standardUserDefaults().removeObjectForKey("MNBrowser_webAppEntrieNames")
    // NSUserDefaults.standardUserDefaults().removeObjectForKey("MNBrowser_webAppEntries")
    // NSUserDefaults.standardUserDefaults().removeObjectForKey('MNBrowser_webApp');
    // NSUserDefaults.standardUserDefaults().removeObjectForKey('MNBrowser_toolbar');
  let defaultEntries = {
      Bing:             { title: '🔍 Bing',           symbol: "🔍", engine: "Bing",     desktop:false, link: "https://www.bing.com/search?q=%s" },
      Baidu:            { title: '🔍 Baidu',          symbol: "🔍", engine: "Baidu",    desktop:false, link: "https://www.baidu.com/s?wd=%s" },
      Zhihu:            { title: '🔍 Zhihu',          symbol: "🔍", engine: "Zhihu",    desktop:false, link: "https://www.zhihu.com/search?type=content&q=%s" },
      Google:           { title: '🔍 Google',         symbol: "🔍", engine: "Google",   desktop:false, link: "https://www.google.com/search?q=%s" },
      Sougou:           { title: '🔍 Sougou',         symbol: "🔍", engine: "Sougou",   desktop:false, link: "https://www.sogou.com/web?query=%s" },
      Wikipedia:        { title: '🔍 Wikipedia',      symbol: "🔍", engine: "Wiki",     desktop:false, link: "https://www.wikipedia.org/w/index.php?search=%s" },
      BaiduTranslate:   { title: '📔 Baidu',          symbol: "📔", engine: "Baidu",    desktop:false, link: "https://fanyi.baidu.com/#en/zh/%s" },
      Deepl:            { title: '📔 Deepl',          symbol: "📔", engine: "Deepl",    desktop:false, link: "https://www.deepl.com/translator#en/zh/%s" },
      Youdao:           { title: '📔 Youdao',         symbol: "📔", engine: "Youdao",   desktop:false, link: "https://dict.youdao.com/m/result?word=%s&lang=en" },
      GoogleTranslate:  { title: '📔 Google',         symbol: "📔", engine: "Google",   desktop:false, link: "https://translate.google.com/?sl=en&tl=zh-CN&text=%s&op=translate" },
      ChatGLM:          { title: '🤖 ChatGLM',        symbol: "🤖", engine: "Chat",     desktop:false, link: "https://chatglm.cn/detail?from=apply" },
      ResearchGate:     { title: '🎓 ResearchGate',   symbol: "🎓", engine: "RG",       desktop:false, link: "https://www.researchgate.net/search.Search.html?query=%s" },
      GoogleScholar:    { title: '🎓 Google Scholar', symbol: "🎓", engine: "Scholar",  desktop:false, link: "https://scholar.google.com/scholar?q=%s" }
    }
  let defaultWebAppEntries = {
      Bilibili:         { title: '📺 Bilibili',       symbol: "📺", engine: "Bilibili", desktop:false, link: "https://www.bilibili.com/" },
      Notion:           { title: '📝 Notion',         symbol: "📝", engine: "Notion",   desktop:false, link: "https://www.notion.so" },
      Wolai:            { title: '📝 Wolai',          symbol: "📝", engine: "Wolai",    desktop:false, link: "https://www.wolai.com" },    
      Craft:            { title: '📝 Craft',          symbol: "📝", engine: "Craft",    desktop:false, link: "https://docs.craft.do" },
      Flomo:            { title: '📝 Flomo',          symbol: "📝", engine: "Flomo",    desktop:false, link: "https://v.flomoapp.com/mine" },
      Flowus:           { title: '📝 Flowus',         symbol: "📝", engine: "Flowus",   desktop:false, link: "https://flowus.cn" },
      Yinian:           { title: '📝 Yinian',         symbol: "📝", engine: "Yinian",   desktop:true, link: "https://www.yinian.pro/note/" },
      Baiduyun:         { title: '☁️ Baiduyun',        symbol: "☁️", engine: "Baidu",    desktop:false, link: "https://pan.baidu.com/disk/main#/index?category=all" },
    }
  let defaultPrompts = {
      Translate:                      {title: "翻译",context:"请翻译接下的提供的每个文本"},
      Keyword:                        {title: "关键词",context:"请为接下来提供的每个文本提取关键词"},
      Title:                          {title: "标题",context:"请为接下来提供的每个文本生成标题"}
  }
  let defaultActionOnNewExcerpt = {
      autoAppear: false,
      autoDynamic: false,
      color: -1
  }
  let entries           = NSUserDefaults.standardUserDefaults().objectForKey('MNBrowser_entries');
  let entrieNames       = NSUserDefaults.standardUserDefaults().objectForKey('MNBrowser_entrieNames');
  let webAppEntries     = NSUserDefaults.standardUserDefaults().objectForKey('MNBrowser_webAppEntries');
  let webAppEntrieNames = NSUserDefaults.standardUserDefaults().objectForKey('MNBrowser_webAppEntrieNames');
  let configOnNewExcerpt = NSUserDefaults.standardUserDefaults().objectForKey('MNBrowser_onNewExcerpt');



  if (!entries || !entrieNames) {
        // Application.sharedInstance().showHUD("useDefault",self.window,2)
    entries = defaultEntries
    entrieNames = Object.keys(entries)
    NSUserDefaults.standardUserDefaults().setObjectForKey(entrieNames,"MNBrowser_entrieNames")
    NSUserDefaults.standardUserDefaults().setObjectForKey(entries,"MNBrowser_entries")
  }
  if (!webAppEntries || !webAppEntrieNames) {
        // Application.sharedInstance().showHUD("useDefault",self.window,2)
    webAppEntries = defaultWebAppEntries
    webAppEntrieNames = Object.keys(webAppEntries)
    NSUserDefaults.standardUserDefaults().setObjectForKey(webAppEntrieNames,"MNBrowser_webAppEntrieNames")
    NSUserDefaults.standardUserDefaults().setObjectForKey(webAppEntries,"MNBrowser_webAppEntries")
  }
  if (!configOnNewExcerpt) {
    configOnNewExcerpt = defaultActionOnNewExcerpt
    NSUserDefaults.standardUserDefaults().setObjectForKey(configOnNewExcerpt,"MNBrowser_onNewExcerpt")
  }
  var textSelected = "";
  var temSender;
  var textProcessed = false;
  var watchMode = false;
  var dateNow = Date.now();
  var dateGetText = Date.now();
  var isNewWindow = false;

  var MNBrowserClass = JSB.defineClass(
    'MNBrowser : JSExtension',
    { /* Instance members */
      sceneWillConnect: function () { //Window initialize
        self.appInstance = Application.sharedInstance();
        self.addonController = browserController.new();
        self.addonController.mainPath = mainPath;
        self.addonController.defaultEntries = defaultEntries
        self.addonController.entries = entries
        self.addonController.entrieNames = entrieNames
        self.addonController.defaultWebAppEntries = defaultWebAppEntries
        self.addonController.webAppEntries = webAppEntries
        self.addonController.webAppEntrieNames = webAppEntrieNames
        self.addonController.prompts = defaultPrompts;
        self.addonController.appearOnNewExcerpt = configOnNewExcerpt.autoAppear;
        self.addonController.autoDynamic = configOnNewExcerpt.autoDynamic;
        self.addonController.processNewExcerptColor = configOnNewExcerpt.color;


        self.rect = '{{0, 0}, {10, 10}}';
        self.arrow = 1;
        // Application.sharedInstance().showHUD(self.addonController.appearOnNewExcerpt,self.window,2)

        // NSNotificationCenter.defaultCenter().addObserverSelectorName(self, 'trst:', 'onReciveTrst');
        // NSNotificationCenter.defaultCenter().addObserverSelectorName(self, 'onClosePopupMenuOnSelection:', 'ClosePopupMenuOnSelection');
      },

      sceneDidDisconnect: function () { // Window disconnect
      },

      sceneWillResignActive: function () { // Window resign active
      },

      sceneDidBecomeActive: function () { // Window become active
      },

      notebookWillOpen: function (notebookid) {
        if (self.appInstance.studyController(self.window).studyMode < 3) {
          self.appInstance.studyController(self.window).refreshAddonCommands();
          self.appInstance.studyController(self.window).view.addSubview(self.addonController.view);
          self.addonController.view.hidden = true;
          self.addonController.webview.loadRequest(
            NSURLRequest.requestWithURL(NSURL.URLWithString(self.addonController.homePageURL))
          );

          NSNotificationCenter.defaultCenter().addObserverSelectorName(self, 'onPopupMenuOnSelection:', 'PopupMenuOnSelection');
          // NSNotificationCenter.defaultCenter().addObserverSelectorName(self, 'onClosePopupMenuOnSelection:', 'ClosePopupMenuOnSelection');
          NSNotificationCenter.defaultCenter().addObserverSelectorName(self, 'onPopupMenuOnNote:', 'PopupMenuOnNote');
          // NSNotificationCenter.defaultCenter().addObserverSelectorName(self, 'onClosePopupMenuOnNote:', 'ClosePopupMenuOnNote');
          NSNotificationCenter.defaultCenter().addObserverSelectorName(self, 'onProcessNewExcerpt:', 'ProcessNewExcerpt');

          NSNotificationCenter.defaultCenter().addObserverSelectorName(self, 'onCloseView:', 'close');
          NSNotificationCenter.defaultCenter().addObserverSelectorName(self, 'onNewWindow:', 'newWindow');


          let engine = NSUserDefaults.standardUserDefaults().objectForKey('MNBrowser_engine');
          let webApp = NSUserDefaults.standardUserDefaults().objectForKey('MNBrowser_webApp');
          let toolbar = NSUserDefaults.standardUserDefaults().objectForKey('MNBrowser_toolbar');
          let dynamic = NSUserDefaults.standardUserDefaults().objectForKey('MNBrowser_dynamic');

          if (engine && entrieNames.includes(engine)) {
            self.addonController.engine = engine
            self.addonController.searchButton.setTitleForState(entries[engine].symbol, 0);
            self.addonController.engineButton.setTitleForState(entries[engine].engine, 0);
          }
          if (webApp && webAppEntrieNames.includes(webApp)) {
            self.addonController.webApp = webApp
            self.addonController.webAppButton.setTitleForState(webAppEntries[webApp].symbol, 0);
            self.addonController.webAppEntriesButton.setTitleForState(webAppEntries[webApp].engine, 0);
          }
          if (toolbar !== undefined) {
            self.addonController.toolbarOn = toolbar
            self.addonController.webAppButton.hidden = !toolbar
            self.addonController.webAppEntriesButton.hidden = !toolbar
            // self.addonController.searchButton.hidden = !toolbar
            self.addonController.homeButton.hidden = !toolbar
            self.addonController.goBackButton.hidden = !toolbar
            self.addonController.goForwardButton.hidden = !toolbar
            self.addonController.refreshButton.hidden = !toolbar
            // self.addonController.screenButton.hidden = !toolbarOn
            self.addonController.engineButton.hidden = !toolbar
            var viewFrame = self.addonController.view.bounds;
            if (self.addonController.toolbarOn) {
              self.addonController.webview.frame = { x: viewFrame.x + 1, y: viewFrame.y + 10, width: viewFrame.width - 2, height: viewFrame.height - 40 }
            } else {
              self.addonController.webview.frame = { x: viewFrame.x + 1, y: viewFrame.y + 10, width: viewFrame.width - 2, height: viewFrame.height }
            }
          }
          if (dynamic !== undefined) {
            self.addonController.dynamic = dynamic
        // Application.sharedInstance().showHUD(dynamic,self.window,2)

          }
          self.customLayoutAddonController();
          NSTimer.scheduledTimerWithTimeInterval(0.2, false, function () {
            self.appInstance.studyController(self.window).becomeFirstResponder(); //For dismiss keyboard on iOS
          });
        }
      },

      notebookWillClose: function (notebookid) {
        // Application.sharedInstance().showHUD("close",self.window,2)
        // self.addonController.homePage()
        watchMode = false;
        textSelected = '';
        NSNotificationCenter.defaultCenter().removeObserverName(self, 'PopupMenuOnSelection');
        NSNotificationCenter.defaultCenter().removeObserverName(self, 'ClosePopupMenuOnSelection');
        NSNotificationCenter.defaultCenter().removeObserverName(self, 'ProcessNewExcerpt');
        NSNotificationCenter.defaultCenter().removeObserverName(self, 'close');
        NSNotificationCenter.defaultCenter().removeObserverName(self, 'newWindow');
      },

      documentDidOpen: function (docmd5) {
      },

      documentWillClose: function (docmd5) {
      },

      controllerWillLayoutSubviews: function (controller) {
        if (controller !== self.appInstance.studyController(self.window)) {
          return;
        };
        if (!self.addonController.view.hidden) {
          let studyFrame = Application.sharedInstance().studyController(this.window).view.bounds
          if (self.addonController.miniMode) {
            let oldFrame = self.addonController.view.frame
            if (oldFrame.x < studyFrame.width*0.5) {
            // self.addonController.view.frame = self.addonController.currentFrame
              self.addonController.view.frame = { x: 0, y: oldFrame.y, width: 40, height: 40 }
            } else {
              self.addonController.view.frame = { x: studyFrame.width - 40, y: oldFrame.y, width: 40, height: 40 }
            }
          } else if (self.addonController.custom) {
            let height = studyFrame.height-10;
            let splitLine = getSplitLine()
            switch (self.addonController.customMode) {
              case "left":
                self.addonController.view.frame = { x: 40, y: 10, width: splitLine - 45, height: height }
                break;
              case "left13":
                self.addonController.view.frame = { x: 40, y: 10, width: studyFrame.width / 3. + 40, height: height}
                break;
              case "right":
                self.addonController.view.frame = { x: splitLine + 5, y: 10, width: studyFrame.width - splitLine - 45, height: height }
                break;
              case "right13":
                self.addonController.view.frame = { x: studyFrame.width * 2 / 3. - 40, y: 10, width: studyFrame.width / 3., height: height }
                break;
              case "full":
                self.addonController.view.frame = { x: 40, y: 10, width: studyFrame.width - 80, height: height }
                break;
              default:
                break;
            }
            self.addonController.webview.frame = self.addonController.view.bounds
          }else{
            let currentFrame = self.addonController.currentFrame
            if (currentFrame.x+currentFrame.width*0.5 >= studyFrame.width) {
              currentFrame.x = studyFrame.width-currentFrame.width*0.5              
            }
            if (currentFrame.y >= studyFrame.height) {
              currentFrame.y = studyFrame.height-20              
            }
            self.addonController.view.frame = currentFrame
            self.addonController.currentFrame = currentFrame
          }
        }
        if (!self.newWindowController || self.newWindowController.view.hidden) {return}
          let studyFrame = Application.sharedInstance().studyController(this.window).view.bounds
          if (self.newWindowController.miniMode) {
            let oldFrame = self.newWindowController.view.frame
            if (oldFrame.x < studyFrame.width*0.5) {
              self.newWindowController.view.frame = { x: 0, y: oldFrame.y, width: 40, height: oldFrame.height }
            } else {
              self.newWindowController.view.frame = { x: studyFrame.width - 40, y: oldFrame.y, width: 40, height: oldFrame.height }
            }
          } else if (self.newWindowController.custom) {
            let height = studyFrame.height-10;
            let splitLine = getSplitLine()
            switch (self.newWindowController.customMode) {
              case "left":
                self.newWindowController.view.frame = { x: 40, y: 10, width: splitLine - 45, height: height }
                break;
              case "left13":
                self.newWindowController.view.frame = { x: 40, y: 10, width: studyFrame.width / 3. + 40, height: height}
                break;
              case "right":
                self.newWindowController.view.frame = { x: splitLine + 5, y: 10, width: studyFrame.width - splitLine - 45, height: height }
                break;
              case "right13":
                self.newWindowController.view.frame = { x: studyFrame.width * 2 / 3. - 40, y: 10, width: studyFrame.width / 3., height: height }
                break;
              case "full":
                self.newWindowController.view.frame = { x: 40, y: 10, width: studyFrame.width - 80, height: height }
                break;
              default:
                break;
            }
            self.newWindowController.webview.frame = self.newWindowController.view.bounds
          }else{
            let currentFrame = self.newWindowController.currentFrame
            if (currentFrame.x+currentFrame.width*0.5 >= studyFrame.width) {
              currentFrame.x = studyFrame.width-currentFrame.width*0.5              
            }
            if (currentFrame.y >= studyFrame.height) {
              currentFrame.y = studyFrame.height-20              
            }
            self.newWindowController.view.frame = currentFrame
            self.newWindowController.currentFrame = currentFrame
          }
      },

      queryAddonCommandStatus: function () {
        if (self.appInstance.studyController(self.window).studyMode < 3) {
          return {
            image: 'logo.png',
            object: self,
            selector: 'toggleAddon:',
            checked: watchMode
          };
        } else {
          return null;
        }
      },

      onPopupMenuOnSelection: function (sender) { // Selecting text on pdf or epub
        isOnSelection = true
        textSelected = encodeURIComponent(sender.userInfo.documentController.selectionText.replaceAll('/', '\\/'));
        self.addonController.selectedText = textSelected
        if (isNewWindow) {
          self.newWindowController.selectedText = textSelected
        }
        dateGetText = Date.now();
        textProcessed = false
        temSender = sender
        if (!self.appInstance.checkNotifySenderInWindow(sender, self.window)) return; // Don't process message from other window
        if (!self.addonController.view.window) return;
        if (self.viewTimer) self.viewTimer.invalidate();
        if (!watchMode) {
          if (!self.addonController.view.hidden) {
            self.addonController.searchButton.backgroundColor = UIColor.colorWithHexString("#5483cd").colorWithAlphaComponent(0.8);
          }
          // self.addonController.webAppButton.backgroundColor = UIColor.colorWithHexString("#6d94d3").colorWithAlphaComponent(0.8);

          if (isNewWindow) {
            self.newWindowController.searchButton.backgroundColor = UIColor.colorWithHexString("#5483cd").colorWithAlphaComponent(0.8);
          }
          self.viewTimer = NSTimer.scheduledTimerWithTimeInterval(5, false, function () {
            self.addonController.searchButton.backgroundColor = UIColor.colorWithHexString("#9bb2d6").colorWithAlphaComponent(0.8);
            // self.addonController.webAppButton.backgroundColor = UIColor.colorWithHexString("#9bb2d6").colorWithAlphaComponent(0.8);
            self.addonController.selectedText = ""
            if (isNewWindow) {
              self.newWindowController.searchButton.backgroundColor = UIColor.colorWithHexString("#9bb2d6").colorWithAlphaComponent(0.8);
            }
            self.viewTimer.invalidate()
          });
          return
        }
        //watch mode

        // var text = sender.userInfo.documentController.selectionText;
        if (textSelected && textSelected.length) {
          self.addonController.search(textSelected);
          if (self.addonController.dynamic) {
            self.layoutAddonController(sender.userInfo.winRect, sender.userInfo.arrow);
          }
          self.addonController.view.hidden = false;
        }
      },
      onProcessNewExcerpt:function (sender) {
        let note = Database.sharedInstance().getNoteById(sender.userInfo.noteid)
        // Application.sharedInstance().showHUD("color: "+note.colorIndex,self.window,5)
        if (self.addonController.processNewExcerptColor !== -1 && note.colorIndex !== self.addonController.processNewExcerptColor) {
          return
        }
        if (self.addonController.appearOnNewExcerpt && textSelected && textSelected.length) {
          self.addonController.search(textSelected);
          if (self.addonController.autoDynamic) {
            self.layoutAddonController(temSender.userInfo.winRect, temSender.userInfo.arrow);
          }
          self.addonController.view.hidden = false;
          self.addonController.webview.hidden = false
        }
        // self.layoutAddonController(temSender)
        // if (watchMode) {
        //   self.addonController.view.hidden = true
        // }
      },
      onPopupMenuOnNote: function (sender) { // Clicking note
        isOnNote = true
        // const frame = self.addonController.view.frame
        // const frameText = `{x:${frame.x},y:${frame.y},width:${frame.width},height:${frame.height}}`
        // Application.sharedInstance().showHUD(frameText,self.window,5)
        currentNoteId = sender.userInfo.note.noteId
        // Application.sharedInstance().showHUD(self.addonController.watchMode,self.window,2)
        let note = Database.sharedInstance().getNoteById(sender.userInfo.note.noteId)
        // Application.sharedInstance().showHUD(note,self.window,2)
        textSelected = encodeURIComponent(note.excerptText ?? note.noteTitle.replaceAll('/', '\\/'))
        self.addonController.selectedText = textSelected
        self.addonController.currentNoteId = currentNoteId
        if (isNewWindow) {
          self.newWindowController.selectedText = textSelected
        }
        dateGetText = Date.now();
        textProcessed = false
        temSender = sender
        // Application.sharedInstance().showHUD(sender.userInfo.note,self.window,2)
        if (!self.appInstance.checkNotifySenderInWindow(sender, self.window)) return; // Don't process message from other window
        if (!self.addonController.view.window) return;
        if (self.viewTimer) self.viewTimer.invalidate();
        if (!watchMode) {
          if (!self.addonController.view.hidden) {
            self.addonController.searchButton.backgroundColor = UIColor.colorWithHexString("#5483cd").colorWithAlphaComponent(0.8);
          }
          if (isNewWindow) {
            self.newWindowController.searchButton.backgroundColor = UIColor.colorWithHexString("#5483cd").colorWithAlphaComponent(0.8);
          }
          self.viewTimer = NSTimer.scheduledTimerWithTimeInterval(5, false, function () {
            self.addonController.searchButton.backgroundColor = UIColor.colorWithHexString("#9bb2d6").colorWithAlphaComponent(0.8);
            // self.addonController.webAppButton.backgroundColor = UIColor.colorWithHexString("#9bb2d6").colorWithAlphaComponent(0.8);
            self.addonController.selectedText = ""
            if (isNewWindow) {
              self.newWindowController.searchButton.backgroundColor = UIColor.colorWithHexString("#9bb2d6").colorWithAlphaComponent(0.8);
            }
            self.viewTimer.invalidate()
          });
          return
        }
        if (textSelected && textSelected.length) {
          self.addonController.search(textSelected);
          if (self.addonController.dynamic) {
            self.layoutAddonController(sender.userInfo.winRect, sender.userInfo.arrow);
          }
          self.addonController.view.hidden = false;
        }
        // self.addonController.view.frame = {x:0,y:0,width:100,height:100}
      },
      onCloseView: function (params) {
        watchMode = false;
        self.appInstance.studyController(self.window).refreshAddonCommands();
        var url = self.addonController.homePageURL
        // var url = 'https://go.itab.link/'
        self.addonController.webview.loadRequest(NSURLRequest.requestWithURL(NSURL.URLWithString(url)));
        // custom = true;
        // self.appInstance.studyController(self.window).view.addSubview(self.addonController.view);

        // self.customLayoutAddonController(123);
        // Application.sharedInstance().showHUD("trst",self.window,2)
        // try {
        // self.layoutAddonController(0,0,true)

        // } catch (error) {
        // Application.sharedInstance().showHUD(error,self.window,2)

        // }
      },
      onNewWindow: function ({userInfo}) {
        if (!isNewWindow) {
          self.newWindowController = browserController.new();
          self.newWindowController.mainPath = mainPath;
          self.newWindowController.defaultEntries = defaultEntries
          self.newWindowController.entries = entries
          self.newWindowController.entrieNames = entrieNames
          self.newWindowController.defaultWebAppEntries = defaultWebAppEntries
          self.newWindowController.webAppEntries = webAppEntries
          self.newWindowController.webAppEntrieNames = webAppEntrieNames
          self.appInstance.studyController(self.window).view.addSubview(self.newWindowController.view);
          isNewWindow = true
          let engine = NSUserDefaults.standardUserDefaults().objectForKey('MNBrowser_engine');
          let webApp = NSUserDefaults.standardUserDefaults().objectForKey('MNBrowser_webApp');
          let toolbar = NSUserDefaults.standardUserDefaults().objectForKey('MNBrowser_toolbar');
          if (engine && entrieNames.includes(engine)) {
            self.newWindowController.engine = engine
            self.newWindowController.searchButton.setTitleForState(entries[engine].symbol, 0);
            self.newWindowController.engineButton.setTitleForState(entries[engine].engine, 0);
          }
          if (webApp && webAppEntrieNames.includes(webApp)) {
            self.newWindowController.webApp = webApp
            self.newWindowController.webAppButton.setTitleForState(webAppEntries[webApp].symbol, 0);
            self.newWindowController.webAppEntriesButton.setTitleForState(webAppEntries[webApp].engine, 0);
          }
          if (toolbar !== undefined) {
            self.newWindowController.toolbarOn = toolbar
            self.newWindowController.webAppButton.hidden = !toolbar
            // self.newWindowController.searchButton.hidden = !toolbar
            self.newWindowController.homeButton.hidden = !toolbar
            self.newWindowController.goBackButton.hidden = !toolbar
            self.newWindowController.goForwardButton.hidden = !toolbar
            self.newWindowController.refreshButton.hidden = !toolbar
            // self.newWindowController.screenButton.hidden = !toolbarOn
            self.newWindowController.engineButton.hidden = !toolbar
            var viewFrame = self.newWindowController.view.bounds;
            if (self.newWindowController.toolbarOn) {
              self.newWindowController.webview.frame = { x: viewFrame.x + 1, y: viewFrame.y + 10, width: viewFrame.width - 2, height: viewFrame.height - 40 }
            } else {
              self.newWindowController.webview.frame = { x: viewFrame.x + 1, y: viewFrame.y + 10, width: viewFrame.width - 2, height: viewFrame.height }
            }
          }
        }
        if (userInfo.desktop) {
          self.newWindowController.webview.customUserAgent = 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/16.0 Safari/605.1.15'
        }else{
          self.newWindowController.webview.customUserAgent = 'Mozilla/5.0 (iPhone; CPU iPhone OS 15_0 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148'
        }
        self.newWindowController.isMainWindow = false
        self.newWindowController.webview.hidden = false;
        self.newWindowController.view.hidden = false;
        self.newWindowController.view.frame = {x:50,y:100,width:417,height:450}
        self.newWindowController.currentFrame = {x:50,y:100,width:417,height:450}
        // Application.sharedInstance().showHUD(userInfo.url, self.window, 5);
        self.newWindowController.webview.loadRequest(NSURLRequest.requestWithURL(NSURL.URLWithString(userInfo.url)));
      },
      toggleAddon: function (sender) {
        if (Date.now() - dateNow < 500) {
          watchMode = true;
          Application.sharedInstance().showHUD("Watch mode", self.window, 2)
          self.appInstance.studyController(self.window).refreshAddonCommands();
          self.addonController.webview.hidden = false
          self.addonController.view.hidden = false
          // if (self.addonController.miniMode) {
          //   Application.sharedInstance().showHUD("Exit", self.window, 2)

          //   // self.addonController.miniMode = false
          //   // // self.layoutAddonController()
          //   // self.addonController.view.frame  = self.addonController.lastFrame
          // }
          return;
        }

        dateNow = Date.now();
        // NSUserDefaults.standardUserDefaults().setObjectForKey(true, 'MNAddon_MdxDict_On');
        // NSUserDefaults.standardUserDefaults().setObjectForKey(true, 'MNAddon_MdxDict_On');
        // popUpOn = true;
        // Application.sharedInstance().showHUD(123,self.window,2)

        if (self.addonController.view.hidden) {
          self.appInstance.studyController(self.window).view.addSubview(self.addonController.view);
        } else {
          if (textProcessed || watchMode) {
            self.addonController.view.hidden = true;
            if (self.addonController.miniMode) {
              self.addonController.miniMode = false
              self.addonController.screenButton.hidden = false
              self.addonController.searchButton.hidden = false
              self.addonController.webAppButton.hidden = false
              self.addonController.closeButton.hidden = false
              self.addonController.maxButton.hidden = false
              let studyFrame = Application.sharedInstance().studyController(this.window).view.bounds
              if (self.addonController.view.frame.x < studyFrame.width*0.5) {
                self.addonController.lastFrame.x = 0
              }else{
                self.addonController.lastFrame.x = studyFrame.width-self.addonController.lastFrame.width
              }
              self.addonController.view.frame  = self.addonController.lastFrame
              self.addonController.currentFrame = self.addonController.lastFrame
              
            }

            watchMode = false;
            self.appInstance.studyController(self.window).refreshAddonCommands();
            return;
          }
        }

        // self.addonController.view.hidden = true;
        // NSNotificationCenter.defaultCenter().addObserverSelectorName(self, 'onPopupMenuOnSelection:', 'PopupMenuOnSelection');
        // NSNotificationCenter.defaultCenter().addObserverSelectorName(self, 'onClosePopupMenuOnSelection:', 'ClosePopupMenuOnSelection');
        NSTimer.scheduledTimerWithTimeInterval(0.2, false, function () {
          self.appInstance.studyController(self.window).becomeFirstResponder(); // For dismiss keyboard on iOS
        });
        if (!self.appInstance.checkNotifySenderInWindow(temSender, self.window)) {
          self.appInstance.studyController(self.window).view.addSubview(self.addonController.view);
          self.addonController.webview.hidden = false;
          // try {
          // self.addonController.homePage('');

          // } catch (error) {

          // Application.sharedInstance().showHUD(error,self.window,2)
          // }
          self.addonController.miniMode = false
          // if (self.addonController.dynamic) {
          // self.customLayoutAddonController();
          // }
          self.addonController.view.hidden = false;
          self.addonController.closeButton.hidden = false
          self.addonController.maxButton.hidden = false
          self.addonController.screenButton.hidden = false
          self.addonController.searchButton.hidden = false
          // Application.sharedInstance().showHUD(self.addonController.toolbarOn,self.window,2)
          // self.addonController.engineButton.hidden = !self.addonController.toolbarOn
          self.addonController.goBackButton.hidden = !self.addonController.toolbarOn
          self.addonController.goForwardButton.hidden = !self.addonController.toolbarOn
          self.addonController.refreshButton.hidden = !self.addonController.toolbarOn
          self.addonController.webAppButton.hidden = !self.addonController.toolbarOn
          self.addonController.homeButton.hidden = !self.addonController.toolbarOn

          textProcessed = true
          return; // Don't process message from other window
        }
        if (!self.addonController.view.window) return;
        if (self.viewTimer) self.viewTimer.invalidate();
        // Application.sharedInstance().showHUD("123",self.window,2)
        var text = textSelected;
        if (text && text.length  && (Date.now() - dateGetText < 5000)) {
          // self.addonController.view.frame = {x:0,y:0,width:100,height:100}
          self.addonController.search(text);
          // self.addonController.homePage(text);
          // self.customLayoutAddonController();
          if (self.addonController.dynamic) {
            self.layoutAddonController(temSender.userInfo.winRect, temSender.userInfo.arrow);
          }
          self.addonController.view.hidden = false;
          self.addonController.miniMode = false
          self.addonController.closeButton.hidden = false
          self.addonController.maxButton.hidden = false
          self.addonController.screenButton.hidden = false
          self.addonController.searchButton.hidden = false
          // self.addonController.engineButton.hidden = !self.addonController.toolbarOn
          self.addonController.goBackButton.hidden = !self.addonController.toolbarOn
          self.addonController.goForwardButton.hidden = !self.addonController.toolbarOn
          self.addonController.refreshButton.hidden = !self.addonController.toolbarOn
          self.addonController.webAppButton.hidden = !self.addonController.toolbarOn
          self.addonController.homeButton.hidden = !self.addonController.toolbarOn
          if (self.addonController.dynamic) {
            self.addonController.toolbarOn = false
            self.addonController.custom = false;
            self.addonController.customMode = "None"
            self.addonController.webAppButton.hidden = true
            // self.addonController.searchButton.hidden = true
            self.addonController.homeButton.hidden = true
            self.addonController.goBackButton.hidden = true
            self.addonController.goForwardButton.hidden = true
            self.addonController.refreshButton.hidden = true
            self.addonController.webAppEntriesButton.hidden = true

            // self.addonController.screenButton.hidden = true
            self.addonController.engineButton.hidden = true
            var viewFrame = self.addonController.view.bounds;
            self.addonController.webview.frame = {x:viewFrame.x+1,y:viewFrame.y+10,width:viewFrame.width-2,height:viewFrame.height}
          }
          textProcessed = true
        } else {
          textProcessed = true
          // self.addonController.homePage(text);
          // Application.sharedInstance().showHUD("No note or text selected",self.window,2)
          if (self.addonController.dynamic) {
            self.layoutAddonController(temSender.userInfo.winRect, temSender.userInfo.arrow);
          }
          self.addonController.view.hidden = false;
          self.addonController.webview.hidden = false;
          self.addonController.miniMode = false
          self.addonController.closeButton.hidden = false
          self.addonController.maxButton.hidden = false
          self.addonController.screenButton.hidden = false
          self.addonController.searchButton.hidden = false
          // self.addonController.engineButton.hidden = !self.addonController.toolbarOn
          self.addonController.goBackButton.hidden = !self.addonController.toolbarOn
          self.addonController.goForwardButton.hidden = !self.addonController.toolbarOn
          self.addonController.refreshButton.hidden = !self.addonController.toolbarOn
          self.addonController.webAppButton.hidden = !self.addonController.toolbarOn
          self.addonController.homeButton.hidden = !self.addonController.toolbarOn
        }
      },
    },
    { /* Class members */
      addonDidConnect: function () {
      },

      addonWillDisconnect: function () {
      },

      applicationWillEnterForeground: function () {
      },

      applicationDidEnterBackground: function () {
      },

      applicationDidReceiveLocalNotification: function (notify) {
      }
    }
  );

  MNBrowserClass.prototype.layoutAddonController = function (rectStr, arrowNum, custom = false) {

    this.rect = rectStr || this.rect;
    this.arrow = arrowNum || this.arrow;
    var x, y
    w = (this.appInstance.osType !== 1) ? 419 : 365, // this.addonController.view.frame.width
      h = 500, // this.addonController.view.frame.height
      fontSize = 15,
      margin = 10,
      padding = 20,
      frame = this.appInstance.studyController(this.window).view.bounds,
      W = frame.width,
      H = frame.height,
      rectArr = this.rect.replace(/{/g, '').replace(/}/g, '').replace(/\s/g, '').split(','),
      X = Number(rectArr[0]),
      Y = Number(rectArr[1]),
      studyMode = this.appInstance.studyController(this.window).studyMode,
      contextMenuWidth = studyMode === 0 ? 225 : 435,
      contextMenuHeight = 35,
      textMenuPadding = 40;

    // this.addonController.view.frame.x
    if (w >= contextMenuWidth) {
      if (X - w / 2 - margin <= 0) {
        x = margin;
      } else if (X + w / 2 + margin >= W) {
        x = W - margin - w;
      } else {
        x = X - w / 2;
      }
    } else {
      if (X - contextMenuWidth / 2 - margin <= 0) {
        x = margin + contextMenuWidth / 2 - w / 2;
      } else if (X + contextMenuWidth / 2 + margin >= W) {
        x = W - margin - contextMenuWidth / 2 - w / 2;
      } else {
        x = X - w / 2;
      }
    }

    // this.addonController.view.frame.[y, height]
    if (this.arrow === 1) {
      let upperBlankHeight = Y - textMenuPadding - fontSize - padding,
        lowerBlankHeight = H - Y - contextMenuHeight - padding;
      if (upperBlankHeight >= lowerBlankHeight) {
        h = (upperBlankHeight >= h) ? h : upperBlankHeight;
        y = upperBlankHeight - h;
      } else {
        y = H - lowerBlankHeight;
        h = (H - y >= h) ? h : H - y;
      }
    } else {
      let upperBlankHeight = Y - textMenuPadding - contextMenuHeight - padding,
        lowerBlankHeight = H - Y - fontSize - padding;
      if (upperBlankHeight >= lowerBlankHeight) {
        h = (upperBlankHeight >= h) ? h : upperBlankHeight;
        y = upperBlankHeight - h;
      } else {
        y = H - lowerBlankHeight;
        h = (H - y >= h) ? h : H - y;
      }
    }
    this.addonController.view.frame = { x: x, y: y, width: w, height: h };
    this.addonController.currentFrame = { x: x, y: y, width: w, height: h };

  };
  MNBrowserClass.prototype.customLayoutAddonController = function (rectStr, arrowNum, custom = false) {

    this.rect = rectStr || this.rect;
    this.arrow = arrowNum || this.arrow;
    var x, y
    w = (this.appInstance.osType !== 1) ? 419 : 365, // this.addonController.view.frame.width
      h = 450, // this.addonController.view.frame.height
      fontSize = 15,
      margin = 10,
      padding = 20,
      frame = this.appInstance.studyController(this.window).view.bounds,
      W = frame.width,
      H = frame.height,
      rectArr = this.rect.replace(/{/g, '').replace(/}/g, '').replace(/\s/g, '').split(','),
      X = Number(rectArr[0]),
      Y = Number(rectArr[1]),
      studyMode = this.appInstance.studyController(this.window).studyMode,
      contextMenuWidth = studyMode === 0 ? 225 : 435,
      contextMenuHeight = 35,
      textMenuPadding = 40;

    // this.addonController.view.frame.x
    if (w >= contextMenuWidth) {
      if (X - w / 2 - margin <= 0) {
        x = margin;
      } else if (X + w / 2 + margin >= W) {
        x = W - margin - w;
      } else {
        x = X - w / 2;
      }
    } else {
      if (X - contextMenuWidth / 2 - margin <= 0) {
        x = margin + contextMenuWidth / 2 - w / 2;
      } else if (X + contextMenuWidth / 2 + margin >= W) {
        x = W - margin - contextMenuWidth / 2 - w / 2;
      } else {
        x = X - w / 2;
      }
    }

    // this.addonController.view.frame.[y, height]
    if (this.arrow === 1) {
      let upperBlankHeight = Y - textMenuPadding - fontSize - padding,
        lowerBlankHeight = H - Y - contextMenuHeight - padding;
      if (upperBlankHeight >= lowerBlankHeight) {
        h = (upperBlankHeight >= h) ? h : upperBlankHeight;
        y = upperBlankHeight - h;
      } else {
        y = H - lowerBlankHeight;
        h = (H - y >= h) ? h : H - y;
      }
    } else {
      let upperBlankHeight = Y - textMenuPadding - contextMenuHeight - padding,
        lowerBlankHeight = H - Y - fontSize - padding;
      if (upperBlankHeight >= lowerBlankHeight) {
        h = (upperBlankHeight >= h) ? h : upperBlankHeight;
        y = upperBlankHeight - h;
      } else {
        y = H - lowerBlankHeight;
        h = (H - y >= h) ? h : H - y;
      }
    }
    this.addonController.view.frame = { x: x, y: y + 50, width: w, height: h };
    this.addonController.currentFrame = { x: x, y: y + 50 , width: w, height: h };
  };
  return MNBrowserClass;
};