
var browserController = JSB.defineClass('browserController : UIViewController', {
  viewDidLoad: function() {
    self.homePageURL = 'https://m.inftab.com/'
    self.homeImage = UIImage.imageWithDataScale(NSData.dataWithContentsOfFile(self.mainPath + `/home.png`), 2)
    self.gobackImage = UIImage.imageWithDataScale(NSData.dataWithContentsOfFile(self.mainPath + `/goback.png`), 2)
    self.goforwardImage = UIImage.imageWithDataScale(NSData.dataWithContentsOfFile(self.mainPath + `/goforward.png`), 2)
    self.reloadImage = UIImage.imageWithDataScale(NSData.dataWithContentsOfFile(self.mainPath + `/reload.png`), 2)
    self.stopImage = UIImage.imageWithDataScale(NSData.dataWithContentsOfFile(self.mainPath + `/stop.png`), 2)
    self.screenImage = UIImage.imageWithDataScale(NSData.dataWithContentsOfFile(self.mainPath + `/screen.png`), 2)
    self.custom = false;
    self.customMode = "None"
    self.dynamic = true;
    self.miniMode = false;
    self.selectedText = '';
    self.searchedText = '';
    self.engine = 'Bing'
    self.webApp = "Bilibili"
    self.isLoading = false;
    self.toolbarOn = true;
    self.lastFrame = self.view.frame;
    self.currentFrame = self.view.frame
    self.isMainWindow = true
    self.title = "main"
    self.test = [0]
    self.view.layer.shadowOffset = {width: 0, height: 0};
    self.view.layer.shadowRadius = 15;
    self.view.layer.shadowOpacity = 0.5;
    self.view.layer.shadowColor = UIColor.colorWithWhiteAlpha(0.5, 1);
    self.view.layer.opacity = 1.0
    // >>> DeepL view >>>
    self.webview = new UIWebView(self.view.bounds);
    // NSUserDefaults.standardUserDefaults().setObjectForKey('Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/13.1.1 Safari/605.1.15',"UserAgent")

    //  Application.sharedInstance().showHUD("error", self.view.window, 2);
    self.webview.url = self.homePageURL;
    self.webview.backgroundColor = UIColor.whiteColor();
    self.webview.scalesPageToFit = true;
    self.webview.autoresizingMask = (1 << 1 | 1 << 4);
    self.webview.delegate = self;
    // self.webview.setValueForKey("Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15_4) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/13.1.1 Safari/605.1.15","User-Agent")
    self.webview.scrollView.delegate = self;
    self.webview.layer.cornerRadius = 15;
    self.webview.layer.masksToBounds = true;
    self.highlightColor = UIColor.blendedColor(
      UIColor.colorWithHexString("#2c4d81").colorWithAlphaComponent(0.8),
      Application.sharedInstance().defaultTextColor,
      0.8
    );
    // >>> DeepL langauge button >>>
    self.webview.lanButton = UIButton.buttonWithType(0);
    // <<< DeepL langauge button <<<
    self.webview.hidden = true;
    self.webview.lastOffset = 0;
    self.view.addSubview(self.webview);
    // <<< DeepL view <<<

// >>> opacity button >>>
    self.webAppButton = UIButton.buttonWithType(0);
    self.setButtonLayout(self.webAppButton,"openWebApp:")
    self.webAppButton.setTitleForState('📺', 0);
    // self.webAppButton.titleLabel.font = UIFont.systemFontOfSize(12);
    // <<< opacity button <<<
    // >>> close button >>>
    self.closeButton = UIButton.buttonWithType(0);
    self.setButtonLayout(self.closeButton,"closeButtonTapped:")
    self.closeButton.setTitleForState('✖️', 0);
    self.closeButton.titleLabel.font = UIFont.systemFontOfSize(10);
    // <<< close button <<<
    // >>> max button >>>
    self.maxButton = UIButton.buttonWithType(0);
    self.setButtonLayout(self.maxButton,"maxButtonTapped:")
    self.maxButton.setTitleForState('➕', 0);
    self.maxButton.titleLabel.font = UIFont.systemFontOfSize(10);
    // <<< max button <<<
    // >>> screen button >>>
    self.screenButton = UIButton.buttonWithType(0);
    self.setButtonLayout(self.screenButton,"changeScreen:")
    self.screenButton.setImageForState(self.screenImage,0)
    // <<< screen button <<<
    // >>> engine button >>>
    self.engineButton = UIButton.buttonWithType(0);
    self.setButtonLayout(self.engineButton,"changeEngine:")
    self.engineButton.setTitleForState('Bing', 0);
    self.engineButton.titleLabel.font = UIFont.boldSystemFontOfSize(14);
    // <<< engine button <<<
    // >>> webAppEntries button >>>
    self.webAppEntriesButton = UIButton.buttonWithType(0);
    self.setButtonLayout(self.webAppEntriesButton,"changeWebApp:")
    self.webAppEntriesButton.setTitleForState('Bilibili', 0);
    self.webAppEntriesButton.titleLabel.font = UIFont.boldSystemFontOfSize(14);
    // <<< webAppEntries button <<<
    // >>> home button >>>
    self.homeButton = UIButton.buttonWithType(0);
    self.setButtonLayout(self.homeButton,"homeButtonTapped:")
    self.homeButton.setImageForState(self.homeImage,0)
    // <<< home button <<<
    // >>> search button >>>
    self.searchButton = UIButton.buttonWithType(0);
    self.setButtonLayout(self.searchButton,"searchButtonTapped:")
    self.searchButton.setTitleForState('🔍', 0);
    // <<< search button <<<
    // >>> move button >>>
    self.moveButton = UIButton.buttonWithType(0);
    self.setButtonLayout(self.moveButton)
    // <<< move button <<<
    // >>> goForward button >>>
    self.goForwardButton = UIButton.buttonWithType(0);
    self.setButtonLayout(self.goForwardButton,"goForwardButtonTapped:")
    self.goForwardButton.setImageForState(self.goforwardImage,0)
    // <<< goForward button <<<
      // >>> goBack button >>>
    self.goBackButton = UIButton.buttonWithType(0);
    self.setButtonLayout(self.goBackButton,"goBackButtonTapped:")
    self.goBackButton.setImageForState(self.gobackImage,0)
    // <<< goBack button <<<
    // >>> refresh button >>>
    self.refreshButton = UIButton.buttonWithType(0);
    self.setButtonLayout(self.refreshButton)
    self.refreshButton.addTargetActionForControlEvents(self, "refreshButtonTapped:", 1 << 6);

    self.refreshButton.setImageForState(self.reloadImage,0)
    // <<< refresh button <<<

    self.moveGesture = new UIPanGestureRecognizer(self,"onMoveGesture:")
    self.moveButton.addGestureRecognizer(self.moveGesture)
    self.moveGesture.view.hidden = false
    self.moveGesture.addTargetAction(self,"onMoveGesture:")

    self.resizeGesture = new UIPanGestureRecognizer(self,"onResizeGesture:")
    self.screenButton.addGestureRecognizer(self.resizeGesture)
    self.resizeGesture.view.hidden = false
    self.resizeGesture.addTargetAction(self,"onResizeGesture:")
  },
  viewWillAppear: function(animated) {
    self.webview.delegate = self;
  },
  viewWillDisappear: function(animated) {
    self.webview.stopLoading();
    self.webview.delegate = null;
    UIApplication.sharedApplication().networkActivityIndicatorVisible = false;
  },
viewWillLayoutSubviews: function() {
    // Application.sharedInstance().showHUD("test", self.view.window, 2);

    if (self.miniMode) {
      // self.webview.hidden = true
      return
    }

    var viewFrame = self.view.bounds;
    var xLeft     = viewFrame.x
    var xRight    = xLeft + viewFrame.width
    var yTop      = viewFrame.y
    var yBottom   = yTop + viewFrame.height
    self.closeButton.frame = {x: xRight-18,y: yTop,width: 18,height: 18};
    self.maxButton.frame   = {x: xRight-43,y: yTop,width: 18,height: 18};
    if (self.toolbarOn) {
      self.screenButton.frame = {x: xRight - 41,y: yBottom - 25,width: 40,height: 25};
    }else{
      self.screenButton.frame = {x: xRight - 40,y: yBottom - 30,width: 33,height: 25};
    }
    self.engineButton.frame = {x: xRight - 106,y: yBottom - 25,width: 60,height: 25};


    if (viewFrame.width <= 300) {
      self.moveButton.frame = {x: xRight*0.5-75,y: yTop,width: viewFrame.width*0.35,height: 12};
      self.refreshButton.hidden = true
      self.goBackButton.hidden = true
      self.goForwardButton.hidden = true
      self.engineButton.hidden = true
      self.webAppEntriesButton.hidden = true
      self.homeButton.frame = {  x: xLeft + (viewFrame.width-200)*0.8,  y: yBottom - 25,  width: 47,  height: 25,};    
      if (self.toolbarOn) {
        self.searchButton.frame = {  x: xLeft + (viewFrame.width-200)*0.8+106,  y: yBottom - 25,  width: 47,  height: 25,};
      }else{
        self.searchButton.frame = {  x: xRight - 75,  y: yBottom - 30,  width: 30,  height: 25,};
      }
      self.webAppButton.frame = {  x: xLeft + (viewFrame.width-200)*0.8+53,  y: yBottom - 25,  width: 47,  height: 25,};
    }else if (viewFrame.width <= 410) {
      self.moveButton.frame = {  x: xRight*0.5-75,  y: yTop,  width: viewFrame.width*0.35,  height: 12,};
      self.refreshButton.hidden = !self.toolbarOn
      self.goBackButton.hidden = !self.toolbarOn
      self.homeButton.hidden = !self.toolbarOn
      self.goForwardButton.hidden = !self.toolbarOn
      self.engineButton.hidden = true
      self.webAppEntriesButton.hidden = true
      self.homeButton.frame = {  x: xLeft + 106,  y: yBottom - 25,  width: 47,  height: 25,};    
      if (self.toolbarOn) {
        self.searchButton.frame = {  x: xRight-92,  y: yBottom - 25,  width: 47,  height: 25,};
      }else{
        self.searchButton.frame = {  x: xRight - 75,  y: yBottom - 30,  width: 30,  height: 25,};
      }
      self.webAppButton.frame = {  x: xRight-144,  y: yBottom - 25,  width: 47,  height: 25,};
    }else{
      self.moveButton.frame = {  x: xRight*0.5-75,  y: yTop,  width: 150,  height: 12,};
      if (self.toolbarOn) {
        self.refreshButton.hidden = false
        self.goBackButton.hidden = false
        self.goForwardButton.hidden = false
        self.engineButton.hidden = false
        self.webAppEntriesButton.hidden = false
      }
      self.homeButton.frame = {  x: xLeft + 106,  y: yBottom - 25,  width:47,  height: 25,};   
      if (self.toolbarOn) {
        self.searchButton.frame = {  x: xRight - 151,  y: yBottom - 25,  width: 40,  height: 25,};
      }else{
        self.searchButton.frame = {  x: xRight - 75,  y: yBottom - 30,  width: 30,  height: 25,}
      }
      self.webAppButton.frame = {  x: xRight - 261,  y: yBottom - 25,  width: 40,  height: 25,};  
      self.webAppEntriesButton.frame = {  x: xRight - 216,  y: yBottom - 25,  width: 60,  height: 25,};  
    }
    self.goBackButton.frame = {  x: xLeft+1,  y: yBottom - 25,  width: 30,  height: 25,};
    self.goForwardButton.frame = {  x: xLeft+36,  y: yBottom - 25,  width: 30,  height: 25,};
    self.refreshButton.frame = {  x: xLeft + 71,  y: yBottom - 25,  width: 30,  height: 25,};
    if (self.toolbarOn) {
      self.webview.frame = {x:xLeft+1,y:yTop+6,width:viewFrame.width-2,height:viewFrame.height-36}
    }else{
      self.webview.frame = {x:xLeft+1,y:yTop+6,width:viewFrame.width-2,height:viewFrame.height-6}
    }
  },
  scrollViewDidScroll: function() {
  },
  webViewDidStartLoad: function(webView) {
    // let requestFromHomepage = self.webview.url === "https://m.inftab.com/"
    let currentURL = webView.request.URL().absoluteString();
    if (!currentURL) {return}
    if (/^marginnote3app/.test(currentURL)) {
      Application.sharedInstance().openURL(NSURL.URLWithString(currentURL));
      webView.stopLoading();
      return
    }
    self.refreshButton.setImageForState(self.stopImage,0)
    self.changeButtonOpacity(0.5)
    if (/(notion.so)|(craft.do)/.test(currentURL)) {
      webView.url = currentURL
      self.refreshButton.setImageForState(self.reloadImage,0)
      self.changeButtonOpacity(1.0)
      return;
    }
    // var pasteBoard = UIPasteboard.generalPasteboard()
    // pasteBoard.string = currentURL
    if (/^https:\/\/d.bilibili/.test(currentURL)) {
      webView.stopLoading();
    }
    if (!self.webAppEntrieNames[self.webApp].desktop && /^bilibili:/.test(currentURL)) {
      // Application.sharedInstance().showHUD("123", self.view.window, 5);
      // webView.stopLoading();
      // webview.scrollView.contentOffset = {x: 0, y: 100}; 
      webView.evaluateJavaScript(
      `//document.getElementsByClassName("launch-app-btn m-float-openapp")[0].style.display = "none";    
      document.getElementsByClassName("launch-app-btn m-nav-openapp")[0].style.display = "none"; 
      document.getElementsByClassName("mplayer-fullscreen-call-app")[0].style.display = "none";
      let itemToRemove = document.getElementsByClassName("mplayer-widescreen-callapp")[0]
      itemToRemove.parentNode.removeChild(itemToRemove)
      itemToRemove = document.getElementsByClassName("m-video2-awaken-btn")[0]
      itemToRemove.parentNode.removeChild(itemToRemove)
      itemToRemove = document.getElementsByClassName("launch-app-btn icon-spread")[0]
      itemToRemove.parentNode.removeChild(itemToRemove)
      // document.getElementsByClassName("m-video-player")[0].style = "position: absolute; width: 100%; height: 100%; left: 0; top: 0;";`,
      (ret) => {
      }
    );         
    }


    // var pasteBoard = UIPasteboard.generalPasteboard()
    // pasteBoard.string = currentURL
    UIApplication.sharedApplication().networkActivityIndicatorVisible = true;
    // self.screenButton.setTitleForState('Loading', 0);
    // self.refreshButton.setTitleForState('✖️', 0);
    self.isLoading = true;
  },
  webViewDidFinishLoad: function(webView) {
    UIApplication.sharedApplication().networkActivityIndicatorVisible = false;
    // self.getCurrentURL(webView)
    // let currentURL = webView.request.URL().absoluteString();
    self.webview.url = webView.request.URL().absoluteString();
    // Application.sharedInstance().showHUD(self.webview.url, self.view.window, 5);
    // self.screenButton.setTitleForState('Screen', 0);
    self.refreshButton.setImageForState(self.reloadImage,0)
    // self.refreshButton.setTitleForState('🔄', 0);
    self.changeButtonOpacity(1.0)
    self.isLoading = false;
    UIApplication.sharedApplication().networkActivityIndicatorVisible = false;
    if (self.webview.url === "https://m.bilibili.com/") {
      self.updateBilibiliOffset()
      return;
    }
    if (/https:\/\/.*\.bing\.com\/search.*/.test(self.webview.url)) {
      self.engine = "Bing"
      self.searchButton.setTitleForState(self.entries[self.engine].symbol, 0);
      self.engineButton.setTitleForState(self.entries[self.engine].engine, 0);
      let searchedText  = self.webview.url.match(/(?<=search\?q=).*/)[0]
      self.searchedText = searchedText
    }else if (/https:\/\/.*\.baidu\.com\/s\?wd.*/.test(self.webview.url)) {
      self.engine = "Baidu"
      self.searchButton.setTitleForState(self.entries[self.engine].symbol, 0);
      self.engineButton.setTitleForState(self.entries[self.engine].engine, 0);
      let searchedText  = self.webview.url.match(/(?<=s\?wd=).*/)[0]
      self.searchedText = searchedText
    }else if (/https:\/\/www\.google\.com\/search.*/.test(self.webview.url)) {
      self.engine = "Google"
      self.searchButton.setTitleForState(self.entries[self.engine].symbol, 0);
      self.engineButton.setTitleForState(self.entries[self.engine].engine, 0);
      let searchedText  = self.webview.url.match(/(?<=search\?q=).*/)[0]
      self.searchedText = searchedText
    }
    switch (self.engine) {
      case "Deepl":
        self.updateDeeplOffset()
        break;
      case "BaiduTranslate":
        self.updateBaiduOffset()
        break;
      case "ResearchGate":
        self.updateRGOffset()
        break;
      case "Bing":
        self.updateBingOffset()
        break;
      case "Youdao":
        self.updateYoudaoOffset()
        break;
      default:
        break;
    }

  },
  webViewDidFailLoadWithError: function(webView, error) {
    // self.screenButton.setTitleForState('Screen', 0);
    self.refreshButton.setImageForState(self.reloadImage,0)
    // self.refreshButton.setTitleForState('🔄', 0);
    self.changeButtonOpacity(1.0)
    self.isLoading = false;
    // self.getCurrentURL()
    //UIApplication.sharedApplication().networkActivityIndicatorVisible = false;
    //var lan = NSLocale.preferredLanguages() ? NSLocale.preferredLanguages()[0].substring(0,2) : 'en';
    //if (lan == 'zh') {
    //  Application.sharedInstance().showHUD('错误', self.view.window, 2);
    //} else {
    //  Application.sharedInstance().showHUD('Failed to load DeepL translator, please try again later', self.view.window, 2);
    //}
  },

  changeScreen: function(sender) {
    //  Application.sharedInstance().showHUD(self.appearOnNewExcerpt, self.view.window, 2);
    if (self.view.popoverController) {self.view.popoverController.dismissPopoverAnimated(true);}
    var menuController = MenuController.new();

    menuController.commandTable = [
      {title:'🌗 Left',object:self,selector:'leftButtonTapped:',param:'left',checked:self.customMode==="left"},
      {title:'🌘 Left 1/3',object:self,selector:'left13ButtonTapped:',param:'left',checked:self.customMode==="left13"},
      {title:'🌓 Right',object:self,selector:'rightButtonTapped:',param:'right',checked:self.customMode==="right"},
      {title:'🌒 Right 1/3',object:self,selector:'right13ButtonTapped:',param:'right',checked:self.customMode==="right13"},
      {title:'🌟 Dynamic',object:self,selector:'dynamicButtonTapped:',param:'right',checked:self.dynamic},
      {title:'🌟 Toolbar',object:self,selector:'toggleToolbar:',param:'right',checked:self.toolbarOn},
      {title:'🌟 OnNewExcerpt',object:self,selector:'onNewExcerpt:',param:sender,checked:self.appearOnNewExcerpt},
      {title:'🌐 Open in new window',object:self,selector:'openInNewWindow:',param:self.webview.url},
      {title:'🌐 Open new window',object:self,selector:'openNewWindow:',param:self.homePageURL},
      {title:'🌐 Open in browser',object:self,selector:'openInBrowser:',param:'right'},
      {title:'🌐 Copy link',object:self,selector:'copyCurrentURL:',param:'right'},
      {title:'🌐 Open copied link',object:self,selector:'openCopiedURL:',param:'right'},
      {title:'🔁 Reset',object:self,selector:'resetConfig:',param:'right'},
      {title:'🫧 Opacity',object:self,selector:'changeOpacity:',param:sender},
      {title:'💾 Upload config',object:self,selector:'uploadConfig:',param:'right'},

      // {title:'⬇ Download',object:self,selector:'downloadConfig:',param:'right'}

    ];
    menuController.rowHeight = 35;
    menuController.preferredContentSize = {
      width: 250,
      height: menuController.rowHeight * menuController.commandTable.length
    };
    var studyController = Application.sharedInstance().studyController(self.view.window);
    self.view.popoverController = new UIPopoverController(menuController);
    var r = sender.convertRectToView(sender.bounds,studyController.view);
    self.view.popoverController.presentPopoverFromRect(r, studyController.view, 1 << 1, true);
  },
  changeEngine: function(sender) {
        // Application.sharedInstance().showHUD(self.entrieNames,self.view.window,2)

    if (self.view.popoverController) {self.view.popoverController.dismissPopoverAnimated(true);}
    var menuController = MenuController.new();
    var commandTable = self.entrieNames.map(entrieName => {
      return {title:self.entries[entrieName].title,object:self,selector:'searchWithEngine:',param:entrieName,checked:self.engine===entrieName}
    }).concat(
      {title:'🖥️ Desktop mode',object:self,selector:'toggleDesktop:',param:"engine", checked:self.entries[self.engine].desktop}
    )
    menuController.commandTable = commandTable
    menuController.rowHeight = 35;
    menuController.preferredContentSize = {
      width: 200,
      height: menuController.rowHeight * menuController.commandTable.length
    };
    var studyController = Application.sharedInstance().studyController(self.view.window);
    self.view.popoverController = new UIPopoverController(menuController);
    var r = sender.convertRectToView(sender.bounds,studyController.view);
    self.view.popoverController.presentPopoverFromRect(r, studyController.view, 1 << 1, true);
  },
  changeWebApp: function(sender) {

        // Application.sharedInstance().showHUD(self.webApp,self.view.window,2)

    if (self.view.popoverController) {self.view.popoverController.dismissPopoverAnimated(true);}
    var menuController = MenuController.new();
    var commandTable = self.webAppEntrieNames.map(entrieName => {
      return {title:self.webAppEntries[entrieName].title,object:self,selector:'changeWebAppTo:',param:entrieName,checked:self.webApp === entrieName}
    })
    .concat({title:'🖥️ Desktop mode',object:self,selector:'toggleDesktop:',param:"webApp", checked:self.webAppEntries[self.webApp].desktop})
    menuController.commandTable = commandTable
    menuController.rowHeight = 35;
    menuController.preferredContentSize = {
      width: 200,
      height: menuController.rowHeight * menuController.commandTable.length
    };
    var studyController = Application.sharedInstance().studyController(self.view.window);
    self.view.popoverController = new UIPopoverController(menuController);
    var r = sender.convertRectToView(sender.bounds,studyController.view);
    self.view.popoverController.presentPopoverFromRect(r, studyController.view, 1 << 1, true);
  },
  changeOpacity: function(sender) {
    if (self.view.popoverController) {self.view.popoverController.dismissPopoverAnimated(true);}
    var menuController = MenuController.new();
    menuController.commandTable = [
      {title:'100%',object:self,selector:'changeOpacityTo:',param:1.0},
      {title:'90%',object:self,selector:'changeOpacityTo:',param:0.9},
      {title:'80%',object:self,selector:'changeOpacityTo:',param:0.8},
      {title:'70%',object:self,selector:'changeOpacityTo:',param:0.7},
      {title:'60%',object:self,selector:'changeOpacityTo:',param:0.6},
      {title:'50%',object:self,selector:'changeOpacityTo:',param:0.5}
    ];
    menuController.rowHeight = 35;
    menuController.preferredContentSize = {
      width: 100,
      height: menuController.rowHeight * menuController.commandTable.length
    };
    var studyController = Application.sharedInstance().studyController(self.view.window);
    self.view.popoverController = new UIPopoverController(menuController);
    var r = sender.convertRectToView(sender.bounds,studyController.view);
    self.view.popoverController.presentPopoverFromRect(r, studyController.view, 1 << 1, true);
  },
  onNewExcerpt: function(sender) {
    // if (params.action) {
    //   if (params.action === "toggle auto appear") {
    //     // self.view.popoverController.dismissPopoverAnimated(true);
    //     self.appearOnNewExcerpt = !self.appearOnNewExcerpt
    //   }
    //   if (params.action === "toggle auto dynamic") {
    //     self.autoDynamic = !self.autoDynamic
    //   }
    // }
    // if (params.color) {
    //   self.processNewExcerptColor = params.color
    // }
    if (self.view.popoverController) {self.view.popoverController.dismissPopoverAnimated(true);}
    var menuController = MenuController.new();
    menuController.commandTable = [
      {title:'🌟 Auto appear',      object:self,selector:'ConfigOnNewExcerpt:',param:{action:"toggle auto appear"},checked:self.appearOnNewExcerpt},
      {title:'🌟 Auto dynamic',     object:self,selector:'ConfigOnNewExcerpt:',param:{action:"toggle auto dynamic"},checked:self.autoDynamic},
      {title:'🌟 For all color',    object:self,selector:'ConfigOnNewExcerpt:',param:{color:-1},checked:self.processNewExcerptColor === -1},
      {title:'🌟 Light yellow only',object:self,selector:'ConfigOnNewExcerpt:',param:{color:0}, checked:self.processNewExcerptColor === 0},
      {title:'🌟 Light green only', object:self,selector:'ConfigOnNewExcerpt:',param:{color:1}, checked:self.processNewExcerptColor === 1},
      {title:'🌟 Light blue only',  object:self,selector:'ConfigOnNewExcerpt:',param:{color:2}, checked:self.processNewExcerptColor === 2},
      {title:'🌟 Pink only',        object:self,selector:'ConfigOnNewExcerpt:',param:{color:3}, checked:self.processNewExcerptColor === 3},
      {title:'🌟 Yellow only',      object:self,selector:'ConfigOnNewExcerpt:',param:{color:4}, checked:self.processNewExcerptColor === 4},
      {title:'🌟 Green only',       object:self,selector:'ConfigOnNewExcerpt:',param:{color:5}, checked:self.processNewExcerptColor === 5},
      {title:'🌟 Blue only',        object:self,selector:'ConfigOnNewExcerpt:',param:{color:6}, checked:self.processNewExcerptColor === 6},
      {title:'🌟 Red only',         object:self,selector:'ConfigOnNewExcerpt:',param:{color:7}, checked:self.processNewExcerptColor === 7},
      {title:'🌟 Orange only',      object:self,selector:'ConfigOnNewExcerpt:',param:{color:8}, checked:self.processNewExcerptColor === 8},
      {title:'🌟 Dark green only',  object:self,selector:'ConfigOnNewExcerpt:',param:{color:9}, checked:self.processNewExcerptColor === 9},
      {title:'🌟 Dark blue only',   object:self,selector:'ConfigOnNewExcerpt:',param:{color:10},checked:self.processNewExcerptColor === 10},
      {title:'🌟 Dark red only',    object:self,selector:'ConfigOnNewExcerpt:',param:{color:11},checked:self.processNewExcerptColor === 11},
      {title:'🌟 White only',       object:self,selector:'ConfigOnNewExcerpt:',param:{color:12},checked:self.processNewExcerptColor === 12},
      {title:'🌟 Light grey only',  object:self,selector:'ConfigOnNewExcerpt:',param:{color:13},checked:self.processNewExcerptColor === 13},
      {title:'🌟 Grey only',        object:self,selector:'ConfigOnNewExcerpt:',param:{color:14},checked:self.processNewExcerptColor === 14},
      {title:'🌟 Purple only',      object:self,selector:'ConfigOnNewExcerpt:',param:{color:15},checked:self.processNewExcerptColor === 15}
    ];
    menuController.rowHeight = 35;
    menuController.preferredContentSize = {
      width: 220,
      height: menuController.rowHeight * menuController.commandTable.length
    };
    var studyController = Application.sharedInstance().studyController(self.view.window);
    self.view.popoverController = new UIPopoverController(menuController);
    var r = sender.convertRectToView(sender.bounds,studyController.view);
    self.view.popoverController.presentPopoverFromRect(r, studyController.view, 1 << 1, true);
  },
  changeOpacityTo:function (opacity) {
    self.view.layer.opacity = opacity
    // self.webAppButton.setTitleForState(`${opacity*100}%`, 0);
  },
  toggleToolbar:function (opacity) {
    if (self.view.popoverController) {self.view.popoverController.dismissPopoverAnimated(true);}

    // self.view.popoverController.dismissPopoverAnimated(true);
    // Application.sharedInstance().showHUD(self.toolbarOn,self.view.window,2)
    self.toolbarOn = !self.toolbarOn
    NSUserDefaults.standardUserDefaults().setObjectForKey(self.toolbarOn, 'MNBrowser_toolbar');
    self.webAppButton.hidden = !self.toolbarOn
    // self.searchButton.hidden = !self.toolbarOn
    self.homeButton.hidden = !self.toolbarOn
    self.goBackButton.hidden = !self.toolbarOn
    self.goForwardButton.hidden = !self.toolbarOn
    self.refreshButton.hidden = !self.toolbarOn
    self.webAppEntriesButton.hidden = !self.toolbarOn

    // self.screenButton.hidden = !self.toolbarOn
    self.engineButton.hidden = !self.toolbarOn
    var viewFrame = self.view.bounds;
    if (self.toolbarOn) {
      self.webview.frame = {x:viewFrame.x+1,y:viewFrame.y+10,width:viewFrame.width-2,height:viewFrame.height-40}
    }else{
      self.webview.frame = {x:viewFrame.x+1,y:viewFrame.y+10,width:viewFrame.width-2,height:viewFrame.height}
    }
  },
  toggleDesktop:function (param) {
    if (self.view.popoverController) {self.view.popoverController.dismissPopoverAnimated(true);}

    // self.view.popoverController.dismissPopoverAnimated(true);
    let desktop
    switch (param) {
      case "engine":
        self.entries[self.engine].desktop = !self.entries[self.engine].desktop
        desktop = self.entries[self.engine].desktop;
        NSUserDefaults.standardUserDefaults().setObjectForKey(self.entries,"MNBrowser_entries")
        break;
      case "webApp":
        self.webAppEntries[self.webApp].desktop = !self.webAppEntries[self.webApp].desktop
        desktop = self.webAppEntries[self.webApp].desktop;
        NSUserDefaults.standardUserDefaults().setObjectForKey(self.webAppEntries,"MNBrowser_webAppEntries")
    // Application.sharedInstance().showHUD(desktop,self.view.window,2)
        break;
      default:
        break;
    }
    if (desktop) {
      self.webview.customUserAgent = 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/16.0 Safari/605.1.15'
      if (param === "engine" && self.engine === "Baidu") {
        let newURL = self.webview.url.replace("m.baidu","www.baidu")
        self.webview.loadRequest(NSURLRequest.requestWithURL(NSURL.URLWithString(newURL))); 
        return;
      }
    }else{
    // Application.sharedInstance().showHUD("mobile",self.view.window,2)
      self.webview.customUserAgent = 'Mozilla/5.0 (iPhone; CPU iPhone OS 15_0 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148'
      if (param === "engine" && self.engine === "Baidu") {
        let newURL = self.webview.url.replace("www.baidu","m.baidu")
        self.webview.loadRequest(NSURLRequest.requestWithURL(NSURL.URLWithString(newURL))); 
        return;
      }
    }

    self.webview.reload();
  },
  searchWithEngine: function (engine) {
    self.engine = engine
    NSUserDefaults.standardUserDefaults().setObjectForKey(engine, 'MNBrowser_engine');
    if (self.selectedText.length) {
      self.search(self.selectedText) 
    }else{
      self.search(self.searchedText)//用户可能只是想换个搜索引擎再次搜索
    }
    if (self.view.popoverController) {self.view.popoverController.dismissPopoverAnimated(true);}

    // self.view.popoverController.dismissPopoverAnimated(true);
  },
  openInNewWindow: function (url) {
    NSNotificationCenter.defaultCenter().postNotificationNameObjectUserInfo('newWindow', self.view.window, {url:url,desktop:self.entries[self.engine].desktop,engine:self.engine,webApp:self.webApp})
    self.homePage();
  },
  openNewWindow: function (url) {
    NSNotificationCenter.defaultCenter().postNotificationNameObjectUserInfo('newWindow', self.view.window, {url:self.homePageURL,desktop:self.entries[self.engine].desktop,engine:self.engine,webApp:self.webApp})
  },
  openInBrowser: function (engine) {
    Application.sharedInstance().openURL(NSURL.URLWithString(self.webview.url));
  },
  copyCurrentURL: function (engine) {
    var pasteBoard = UIPasteboard.generalPasteboard()
    pasteBoard.string = self.webview.url
    // Application.sharedInstance().showHUD(self.webview.url,self.view.window,2)
    // Application.sharedInstance().openURL(NSURL.URLWithString(self.webview.url));
  },
  openCopiedURL: function (engine) {
    var pasteBoard = UIPasteboard.generalPasteboard()
    self.webview.loadRequest(NSURLRequest.requestWithURL(NSURL.URLWithString(pasteBoard.string)));
    // Application.sharedInstance().openURL(NSURL.URLWithString(self.webview.url));
  },
  ConfigOnNewExcerpt: function (params) {
    if (self.view.popoverController) {self.view.popoverController.dismissPopoverAnimated(true);}

    // self.view.popoverController.dismissPopoverAnimated(true);
    // Application.sharedInstance().showHUD(self.processNewExcerptColor,self.view.window,2)
    let config = {
      autoAppear: self.appearOnNewExcerpt,
      autoDynamic: self.autoDynamic,
      color: self.processNewExcerptColor
    }
    if (params.action) {
      if (params.action === "toggle auto appear") {
        // self.view.popoverController.dismissPopoverAnimated(true);
        self.appearOnNewExcerpt = !self.appearOnNewExcerpt
        config.autoAppear = self.appearOnNewExcerpt
      }
      if (params.action === "toggle auto dynamic") {
        self.autoDynamic = !self.autoDynamic
        config.autoDynamic = self.autoDynamic
      }
    }
    if (params.color) {
      self.processNewExcerptColor = params.color
      config.color = self.processNewExcerptColor
    }
    NSUserDefaults.standardUserDefaults().setObjectForKey(config,"MNBrowser_onNewExcerpt")
  },
  resetConfig: function (engine) {
    self.entries = self.defaultEntries
    self.entrieNames = Object.keys(self.entries)
    self.engine = self.entrieNames[0]
    self.webAppEntries = self.defaultWebAppEntries
    self.webAppEntrieNames = Object.keys(self.webAppEntries)
    self.webApp = self.webAppEntrieNames[0]
    self.toolbarOn = true
    self.searchButton.setTitleForState(self.entries[self.engine].symbol, 0);
    self.engineButton.setTitleForState(self.entries[self.engine].engine, 0);
    self.webAppButton.setTitleForState(self.webAppEntries[self.webApp].symbol, 0);
    self.webAppEntriesButton.setTitleForState(self.webAppEntries[self.webApp].engine, 0);
    NSUserDefaults.standardUserDefaults().removeObjectForKey("MNBrowser_entrieNames")
    NSUserDefaults.standardUserDefaults().removeObjectForKey("MNBrowser_entries")
    NSUserDefaults.standardUserDefaults().removeObjectForKey('MNBrowser_engine');
    NSUserDefaults.standardUserDefaults().removeObjectForKey("MNBrowser_webAppEntrieNames")
    NSUserDefaults.standardUserDefaults().removeObjectForKey("MNBrowser_webAppEntries")
    NSUserDefaults.standardUserDefaults().removeObjectForKey('MNBrowser_webApp');
    NSUserDefaults.standardUserDefaults().removeObjectForKey('MNBrowser_toolbar');
  },
  uploadConfig: function (engine) {

    let note = Database.sharedInstance().getNoteById(self.currentNoteId)
    let customEntries
    let commentsLength = note.comments.length
    if (commentsLength === 0) {
      Application.sharedInstance().showHUD("No comments found",self.view.window,2)
      return;
    }
    try {
      let comment = note.comments[0].text.replaceAll(`”`,`"`).replaceAll(`“`,`"`)
      customEntries = JSON.parse(comment)
      if (!Object.keys(customEntries).length) {
        Application.sharedInstance().showHUD("Invalid config",self.view.window,2)
        return;
      }
      // Application.sharedInstance().showHUD(Object.keys(customEntries).length,self.view.window,2)
    } catch (error) {
      Application.sharedInstance().showHUD(error,self.view.window,2)
      return;
    }
    let uploadLog = [];
    if (customEntries.Search) {
      uploadLog.push(`"Search"`)
      self.entries = customEntries.Search
      self.entrieNames = Object.keys(self.entries)
      self.engine = self.entrieNames[0]
      self.searchButton.setTitleForState(self.entries[self.engine].symbol, 0);
      self.engineButton.setTitleForState(self.entries[self.engine].engine, 0);
      NSUserDefaults.standardUserDefaults().setObjectForKey(self.entrieNames,"MNBrowser_entrieNames")
      NSUserDefaults.standardUserDefaults().setObjectForKey(self.entries,"MNBrowser_entries")
      NSUserDefaults.standardUserDefaults().setObjectForKey(self.engine,'MNBrowser_engine');
    }
    if (customEntries.WebApp) {
      uploadLog.push(`"WebApp"`)
      self.webAppEntries = customEntries.WebApp
      self.webAppEntrieNames = Object.keys(self.webAppEntries)
      self.webApp = self.webAppEntrieNames[0]
      self.webAppButton.setTitleForState(self.webAppEntries[self.webApp].symbol, 0);
      self.webAppEntriesButton.setTitleForState(self.webAppEntries[self.webApp].engine, 0);
      NSUserDefaults.standardUserDefaults().setObjectForKey(self.webAppEntrieNames,"MNBrowser_webAppEntrieNames")
      NSUserDefaults.standardUserDefaults().setObjectForKey(self.webAppEntries,"MNBrowser_webAppEntries")
      NSUserDefaults.standardUserDefaults().setObjectForKey(self.webApp,'MNBrowser_webApp');
    }
    if (uploadLog.length) {
      Application.sharedInstance().showHUD("Upload config of "+uploadLog.join(" and ")+" success!",self.view.window,2)
    }else{
      Application.sharedInstance().showHUD('Entries of "Search" or "WebApp" not found',self.view.window,2)
    }
  },
  homeButtonTapped: function() {
    self.homePage()
  },
  searchButtonTapped: function() {
    // self.webview.goBack();
    // Application.sharedInstance().showHUD(self.webview.url === self.entries[self.engine].link,self.view.window,2)
    if (self.engine === "ChatGLM" && self.webview.url === self.entries[self.engine].link) {
      let text  = decodeURIComponent(self.selectedText);
      if (!text.length) {
        let options = Object.keys(self.prompts).map(opt=>self.prompts[opt].title)
        let prompts = Object.keys(self.prompts).map(opt=>self.prompts[opt].context)
        // let option = ["请为接下来提供的每个文本生成标题","请翻译接下的提供的每个文本","请为接下来提供的每个文本提取关键词","请翻译接下来提供的每个文本并提取关键词"]
        UIAlertView.showWithTitleMessageStyleCancelButtonTitleOtherButtonTitlesTapBlock(
        "选择预设","",0,"取消",options,
        (alert, buttonIndex) => {
          if (buttonIndex>0) {
            self.webview.evaluateJavaScript(
              `if (typeof(t) !== "undefined") {
                t.value='${prompts[buttonIndex-1]}';
                t.dispatchEvent(evt)
              }else{
                let t = document.getElementsByTagName('textarea')[0];
                let evt = document.createEvent('HTMLEvents');
                evt.initEvent('input', true, true);
                t.value='${prompts[buttonIndex-1]}';
                t.dispatchEvent(evt)
              }
              setTimeout(() => {
                  document.getElementsByClassName('button-right-inner')[0].click();
                }, 200)
              `,
              (ret)=>{}
            )
          }
        })
      }else{
        self.webview.evaluateJavaScript(
          `if (typeof(t) !== "undefined") {
            t.value='${text}';
            t.dispatchEvent(evt)
          }else{
            let t = document.getElementsByTagName('textarea')[0];
            let evt = document.createEvent('HTMLEvents');
            evt.initEvent('input', true, true);
            t.value='${text}';
            t.dispatchEvent(evt)
          }
          setTimeout(() => {
              document.getElementsByClassName('button-right-inner')[0].click();
            }, 200)
          `,
          (ret)=>{}
        )
      }
      return;
    }
    self.search(self.selectedText)
  },
  goBackButtonTapped: function() {
    self.webview.goBack();
  },
  goForwardButtonTapped: function() {
    self.webview.goForward();
  },
  refreshButtonTapped: function(para) {

    if (self.isLoading) {
      self.webview.stopLoading();
      self.refreshButton.setImageForState(self.reloadImage,0)
      self.changeButtonOpacity(1.0)
      self.isLoading = false;
    }else{
      self.webview.reload();
    }
  },
  dynamicButtonTapped: function() {
    if (self.view.popoverController) {self.view.popoverController.dismissPopoverAnimated(true);}

    // self.view.popoverController.dismissPopoverAnimated(true);
    // self.switchView();
    self.dynamic = true;
    self.toolbarOn = false
    self.custom = false;
    self.customMode = "None"
    self.webAppButton.hidden = true
    // self.searchButton.hidden = true
    self.homeButton.hidden = true
    self.goBackButton.hidden = true
    self.goForwardButton.hidden = true
    self.refreshButton.hidden = true
    self.webAppEntriesButton.hidden = true

    // self.screenButton.hidden = true
    self.engineButton.hidden = true
    var viewFrame = self.view.bounds;
    self.webview.frame = {x:viewFrame.x+1,y:viewFrame.y+10,width:viewFrame.width-2,height:viewFrame.height}
    NSUserDefaults.standardUserDefaults().setObjectForKey(true,"MNBrowser_dynamic")
    
    // self.view.frame = {x:100,y:100,width:100,height:100}
    // self.close();
  },
  closeButtonTapped: function() {
    self.view.hidden = true;
    // self.custom = false;
    // self.dynamic = true;

    var url = 'https://m.inftab.com/'
    // var url = 'https://www.bilibili.com/online.html'
    self.webview.loadRequest(NSURLRequest.requestWithURL(NSURL.URLWithString(url)));
    self.searchedText = ""
  // Application.sharedInstance().showHUD(self.isMainWindow,self.view.window,2)

    if (self.isMainWindow) {
      NSNotificationCenter.defaultCenter().postNotificationNameObjectUserInfo('close', self.view.window, {test:123})
      
    }
    NSUserDefaults.standardUserDefaults().setObjectForKey(self.dynamic,"MNBrowser_dynamic")
    },
  leftButtonTapped: function() {
    if (self.view.popoverController) {self.view.popoverController.dismissPopoverAnimated(true);}

    // self.view.popoverController.dismissPopoverAnimated(true);
    self.lastFrame = self.view.frame
    let studyFrame = Application.sharedInstance().studyController(this.window).view.bounds
    let height = studyFrame.height;
    let splitLine = getSplitLine()
    // Application.sharedInstance().showHUD(splitLine,self.view.window,2)
    self.view.frame = {x:40,y:50,width:splitLine-40,height:height-50}
    self.custom = true;
    self.customMode = "left"
    self.dynamic = false;
    self.webview.hidden = false
    self.moveButton.hidden = false
    self.maxButton.hidden = false
    self.closeButton.hidden = false
  },
  left13ButtonTapped: function() {
    if (self.view.popoverController) {self.view.popoverController.dismissPopoverAnimated(true);}
    self.customMode = "left13"
    self.dynamic = false;
    self.lastFrame = self.view.frame

    // self.view.popoverController.dismissPopoverAnimated(true);
    let studyFrame = Application.sharedInstance().studyController(this.window).view.bounds
    let height = studyFrame.height;
    let splitLine = getSplitLine()
    // Application.sharedInstance().showHUD(splitLine,self.view.window,2)
    self.view.frame = {x:40,y:60,width:studyFrame.width/3.+40,height:height-60}
    self.custom = true;
    self.webview.hidden = false
    self.moveButton.hidden = false
    self.maxButton.hidden = false
    self.closeButton.hidden = false
  },
  rightButtonTapped: function() {
    if (self.view.popoverController) {self.view.popoverController.dismissPopoverAnimated(true);}
    self.customMode = "right"
    self.dynamic = false;
    self.lastFrame = self.view.frame
    // self.view.popoverController.dismissPopoverAnimated(true);
    let studyFrame = Application.sharedInstance().studyController(this.window).view.bounds
    let height = studyFrame.height;
    let splitLine = getSplitLine()
    self.view.frame = {x:splitLine,y:50,width:studyFrame.width-splitLine-40,height:height-50}
    self.custom = true;
    self.webview.hidden = false
    self.moveButton.hidden = false
    self.maxButton.hidden = false
    self.closeButton.hidden = false
  },
  right13ButtonTapped: function() {
    if (self.view.popoverController) {self.view.popoverController.dismissPopoverAnimated(true);}
    self.custom = true;
    self.customMode = "right13"
    self.dynamic = false;
    self.lastFrame = self.view.frame
    // self.view.popoverController.dismissPopoverAnimated(true);
    let studyFrame = Application.sharedInstance().studyController(this.window).view.bounds
    let height = studyFrame.height;
    let splitLine = getSplitLine()
    self.view.frame = {x:splitLine,y:50,width:studyFrame.width-splitLine-40,height:height-50}
    self.webview.hidden = false
    self.moveButton.hidden = false
    self.maxButton.hidden = false
    self.closeButton.hidden = false
  },
  maxButtonTapped: function() {
    if (self.customMode === "full") {
      self.customMode = "none"
      self.custom = false;
      self.view.frame = self.lastFrame
      return
    }
    const frame = Application.sharedInstance().studyController(this.window).view.bounds
    self.lastFrame = self.view.frame
    self.view.frame = {x:40,y:50,width:frame.width-80,height:frame.height-70}
    self.customMode = "full"
    self.custom = true;
    self.dynamic = false;
    self.webview.hidden = false
  },
  onMoveGesture:function (gesture) {
    self.dynamic = false;
    let baseframe = gesture.view.frame
    let locationInView = gesture.locationInView(gesture.view)
    let translationX = locationInView.x - baseframe.width*0.5
    let translationY = locationInView.y - baseframe.height*0.5
    let frame = self.view.frame
    var viewFrame = self.view.bounds;
    let studyFrame = Application.sharedInstance().studyController(self.view.window).view.bounds
    let y = frame.y+translationY
    if (y<=0) {
      y = 0
    }
    if (y>=studyFrame.height-15) {
      y = studyFrame.height-15
    }
    let x = frame.x+translationX
    if (!self.miniMode) {
      if (x+frame.width*0.5-40<0) {
        self.miniMode = true 
        self.dynamic = false    
        self.lastFrame = frame 
        self.webview.hidden = true
        self.view.frame = {
          x:0,
          y:frame.y,
          width:40,
          height:40
        }
        self.currentFrame  = self.view.frame
        self.closeButton.hidden = true
        self.maxButton.hidden = true
        self.screenButton.hidden = true
        self.engineButton.hidden = true
        self.webAppEntriesButton.hidden = true
        self.moveButton.frame = {
          x: -10,
          y: 0,
          width: 50,
          height: 40,
        };
        return
      }
      if (x>studyFrame.width-frame.width*0.5-40) {
        x=studyFrame.width-frame.width*0.5-40
        self.miniMode = true     
        self.dynamic = false    
        self.lastFrame = frame 
        self.webview.hidden = true
        self.view.frame = {
          x:studyFrame.width-40,
          y:frame.y,
          width:40,
          height:40
        }
        self.currentFrame  = self.view.frame
        self.closeButton.hidden = true
        self.maxButton.hidden = true
        self.screenButton.hidden = true
        self.engineButton.hidden = true
        self.goBackButton.hidden = true
        self.goForwardButton.hidden = true
        self.refreshButton.hidden = true
        self.webAppButton.hidden = true
        self.searchButton.hidden = true
        self.homeButton.hidden = true
        self.webAppEntriesButton.hidden = true
        self.moveButton.frame = {
          x: 0,
          y: 0,
          width: 50,
          height: 40,
        };
        return
      }
    }else{
      if (x+frame.width*0.5-50<=0) {
        x = -frame.width*0.5+20
      }else if (x>studyFrame.width-frame.width*0.5-50) {
        x = studyFrame.width-40
      }else{
        self.view.frame = {
          x:40,
          y:y,
          width:self.lastFrame.width,
          height:self.lastFrame.height
        }
        self.currentFrame  = self.view.frame
        viewFrame = self.view.bounds;
        self.miniMode = false
        self.moveButton.frame = {
          x: viewFrame.x + viewFrame.width*0.5-75,
          y: viewFrame.y + 5,
          width: 150,
          height: 10,
        };
        self.webview.hidden = false
        self.closeButton.hidden = false
        self.maxButton.hidden = false
        self.screenButton.hidden = false
        self.searchButton.hidden = false
        if (self.toolbarOn) {
          self.homeButton.hidden = false
          self.engineButton.hidden = false
          self.webAppButton.hidden = false
          self.webAppEntriesButton.hidden = false

        }
        return
      }
    }
    
    if (self.custom) {
      // Application.sharedInstance().showHUD(self.custom, self.view.window, 2);
      self.customMode = "None"
      self.view.frame = {x:x,y:y,width:self.lastFrame.width,height:self.lastFrame.height}
      self.currentFrame  = self.view.frame

    }else{
      self.view.frame = {x:x,y:y,width:frame.width,height:frame.height}
      self.currentFrame  = self.view.frame

    }
    self.custom = false;
  },
  onResizeGesture:function (gesture) {
    self.custom = false;
    self.dynamic = false;
    let baseframe = gesture.view.frame
    let locationInView = gesture.locationInView(gesture.view)
    let frame = self.view.frame
    let width = locationInView.x+baseframe.x+baseframe.width*0.5
    let height = locationInView.y+baseframe.y+baseframe.height*0.5
    if (width <= 200) {
      width = 200
    }
    if (height <= 100) {
      height = 100
    }
    //  Application.sharedInstance().showHUD(`{x:${translation.x},y:${translation.y}}`, self.view.window, 2);
    //  self.view.frame = {x:frame.x,y:frame.y,width:frame.width+translationX,height:frame.height+translationY}
    self.view.frame = {x:frame.x,y:frame.y,width:width,height:height}
    self.currentFrame  = self.view.frame
  },
  changeWebAppTo:function(webApp) {
    if (self.view.popoverController) {self.view.popoverController.dismissPopoverAnimated(true);}
    if (webApp) {
      self.webApp = webApp;
    }
    NSUserDefaults.standardUserDefaults().setObjectForKey(self.webApp, 'MNBrowser_webApp');

    var url;
    url = self.webAppEntries[self.webApp].link
    // Application.sharedInstance().showHUD(url, self.view.window, 2);
    self.webAppButton.setTitleForState(self.webAppEntries[self.webApp].symbol, 0);
    self.webAppEntriesButton.setTitleForState(self.webAppEntries[self.webApp].engine, 0);
    if (self.webAppEntries[self.webApp].desktop) {
      self.webview.customUserAgent = 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/16.0 Safari/605.1.15'
    }else{
      self.webview.customUserAgent = 'Mozilla/5.0 (iPhone; CPU iPhone OS 15_0 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148'
    };
    if (self.webview.url !== url) {
      self.webview.loadRequest(NSURLRequest.requestWithURL(NSURL.URLWithString(url))); 
      self.webview.hidden = false
      return
    }

  },
  openWebApp:function() {
    // NSUserDefaults.standardUserDefaults().synchronize();
    // let object = NSUserDefaults.standardUserDefaults().objectForKey("UserAgent");
    NSUserDefaults.standardUserDefaults().setObjectForKey(self.webApp, 'MNBrowser_webApp');

    var url;
    url = self.webAppEntries[self.webApp].link
    // Application.sharedInstance().showHUD(url, self.view.window, 2);
    // self.webAppButton.setTitleForState(self.webAppEntries[self.webApp].symbol, 0);
    // self.webAppEntriesButton.setTitleForState(self.webAppEntries[self.webApp].engine, 0);
    if (self.webAppEntries[self.webApp].desktop) {
      self.webview.customUserAgent = 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/16.0 Safari/605.1.15'
    }else{
      self.webview.customUserAgent = 'Mozilla/5.0 (iPhone; CPU iPhone OS 15_0 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148'
    };
      self.webview.loadRequest(NSURLRequest.requestWithURL(NSURL.URLWithString(url))); 
      self.webview.hidden = false
  }
});

browserController.prototype.homePage = function() {

  this.webview.loadRequest(NSURLRequest.requestWithURL(NSURL.URLWithString(self.homePageURL)));
  this.webview.hidden = false
  this.searchedText = "";
  // this.mdxDictView.hidden = false
  this.currentView = "deepl"
  // var url = `${this.webview.url}#en/${this.webview.lanCode}/${encodeURIComponent(text.replaceAll('/', '\\/'))}`;
};

browserController.prototype.search = function(text) {
  // NSUserDefaults.standardUserDefaults().synchronize();
  // let object = NSUserDefaults.standardUserDefaults().objectForKey("UserAgent");
    //  Application.sharedInstance().showHUD(text, this.view.window, 2);
  var url;
  url = this.entries[this.engine].link.replace('%s',text)
  // Application.sharedInstance().showHUD(url, this.view.window, 2);
  this.searchButton.setTitleForState(this.entries[this.engine].symbol, 0);
  this.engineButton.setTitleForState(this.entries[this.engine].engine, 0);
  if (this.entries[this.engine].desktop) {
    this.webview.customUserAgent = 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/16.0 Safari/605.1.15'
  }else{
    this.webview.customUserAgent = 'Mozilla/5.0 (iPhone; CPU iPhone OS 15_0 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148'
  };
  if (this.webview.url !== url) {
    this.webview.loadRequest(NSURLRequest.requestWithURL(NSURL.URLWithString(url))); 
    this.webview.hidden = this.miniMode
    this.searchedText = text
    return
  }
  // if (this.engine === "ChatGLM") {
  //   if (!text.length) {
  //     let option = ["请为接下来提供的每个文本生成标题","请翻译接下的提供的每个文本","请为接下来提供的每个文本提取关键词","请翻译接下来提供的每个文本并提取关键词"]
  //     UIAlertView.showWithTitleMessageStyleCancelButtonTitleOtherButtonTitlesTapBlock(
  //     "选择预设","",0,"取消",option,
  //     (alert, buttonIndex) => {
  //       if (buttonIndex>0) {
  //         this.webview.evaluateJavaScript(
  //           `if (typeof(t) !== "undefined") {
  //             t.value='${option[buttonIndex-1]}';
  //             t.dispatchEvent(evt)
  //           }else{
  //             let t = document.getElementsByTagName('textarea')[0];
  //             let evt = document.createEvent('HTMLEvents');
  //             evt.initEvent('input', true, true);
  //             t.value='${option[buttonIndex-1]}';
  //             t.dispatchEvent(evt)
  //           }
  //           setTimeout(() => {
  //               document.getElementsByClassName('button-right-inner')[0].click();
  //             }, 200)
  //           `,
  //           (ret)=>{}
  //         )
  //       }
  //     })
  //   }else{
  //     this.webview.evaluateJavaScript(
  //       `if (typeof(t) !== "undefined") {
  //         t.value='${text}';
  //         t.dispatchEvent(evt)
  //       }else{
  //         let t = document.getElementsByTagName('textarea')[0];
  //         let evt = document.createEvent('HTMLEvents');
  //         evt.initEvent('input', true, true);
  //         t.value='${text}';
  //         t.dispatchEvent(evt)
  //       }
  //       setTimeout(() => {
  //           document.getElementsByClassName('button-right-inner')[0].click();
  //         }, 200)
  //       `,
  //       (ret)=>{}
  //     )
  //   }
  // }
  
};




browserController.prototype.switchView = function() {
    this.webview.hidden = !this.mdxDictView.hidden;
};
browserController.prototype.embedVideo = function(bid) {
    this.webview.evaluateJavaScript(
        `var body = document.getElementsByTagName("body");
    var div = document.createElement("div");
    div.innerHTML = '<iframe class="embedPlayer" style="position: absolute; width: 100%; height: 100%; left: 0; top: 0;" src="//player.bilibili.com/player.html?bvid=${bid}&high_quality=1" scrolling="no" border="0" frameborder="no" framespacing="0"></iframe> ';
    document.body.appendChild(div);`,
        (ret) => {
        ;

      })
};

browserController.prototype.updateDeeplOffset = function() {
  if(!this.webview || !this.webview.window)return;
  if (Application.sharedInstance().osType !== 1) {
    this.webview.evaluateJavaScript(
      `document.getElementsByClassName("dl_header")[0].style.display="none";
       document.getElementsByClassName("lmt__docTrans-tab-container")[0].style.display="none";
       document.getElementsByClassName("lmt__sides_container")[0].style.margin = 0;
       document.querySelector("#dl_translator").style.cssText = "padding-top: 20px";
       document.getElementsByClassName("lmt__language_container")[0].style.display = "none";
       document.getElementsByClassName("lmt__language_container")[1].style.display = "none";
       document.getElementsByClassName("lmt__target_toolbar")[0].style.display = "none";
       document.querySelector("#dl_cookieBanner").style.display="none";
       document.querySelector("#lmt_quotes_article").style.display="none";
       document.querySelector("#lmt__dict").style.margin = 0;
       document.querySelector("#lmt_pro_ad_container").style.display = "none";
       document.querySelector("body > div.dl_footerV2_container").style.display = "none";`,
      (ret) => {}
    );
  } else {
    this.webview.evaluateJavaScript(
      `document.querySelector("#gatsby-focus-wrapper > header").style.display = "none";
       document.querySelector("#gatsby-focus-wrapper > footer").style.display = "none";
       document.getElementsByClassName("TranslatorPage-module--otherSections--3cbQ7")[0].style.display = "none";`,
      (ret) => {}
    );
  }
  this.webview.evaluateJavaScript(
    'document.getElementsByClassName("lmt__side_container--target")[0].getBoundingClientRect().top + document.body.scrollTop+document.documentElement.scrollTop;',
    function (ret) {
      if (!this.webview) return;
      if (ret && !isNaN(parseFloat(ret))) {
        this.webview.scrollView.contentOffset = {x: 0, y: parseFloat(ret) + 0};          
      } else {
        this.webview.scrollView.contentOffset = {x: 0, y: 130};          
      }
    }
  );
};

browserController.prototype.updateBaiduOffset = function() {
  if(!this.webview || !this.webview.window)return;
  this.webview.evaluateJavaScript(
    `document.getElementsByClassName("new-header")[0].style.display = "none";`,
    (ret) => {}
  );
};

browserController.prototype.updateBingOffset = function() {
  if(!this.webview || !this.webview.window)return;
    this.viewTimer = NSTimer.scheduledTimerWithTimeInterval(0.5, true, () => {
        this.webview.evaluateJavaScript(
          `document.getElementsByClassName("bottom bnp_rich_div_visible")[0].style.display = "none"
          var customUserAgent = 'Mozilla/5.0 (Linux; U; Android 7.0; zh-CN; PRO 7-S Build/NRD90M) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/57.0.2987.108 UCBrowser/11.9.4.974 UWS/2.13.2.46 Mobile Safari/537.36 AliApp(DingTalk/4.6.29) com.alibaba.android.rimet/11388461 Channel/10002068 language/zh-CN';
 
//修改后的userAgent            
            Object.defineProperty(navigator, 'userAgent', {
              value: customUserAgent,
              writable: false
            });
 
//打印
 
console.log(navigator.userAgent);`,
          (ret) => {}
        );
        this.viewTimer.invalidate();
    });

};
browserController.prototype.updateYoudaoOffset = function() {
  if(!this.webview || !this.webview.window)return;
  this.webview.evaluateJavaScript(
    `document.getElementsByClassName("top-download")[0].style.display = "none";`,
    (ret) => {}
  );
};
browserController.prototype.updateRGOffset = function() {
  if(!this.webview || !this.webview.window)return;
  this.webview.evaluateJavaScript(
    `document.getElementsByClassName("header")[0].style.display = "none"`,
    (ret) => {}
  );
};

browserController.prototype.updateBilibiliOffset = function() {
  if(!this.webview || !this.webview.window)return;

    this.webview.evaluateJavaScript(
      `document.getElementsByClassName("m-home-float-openapp")[0].style.display = "none"; 
      document.getElementsByClassName("launch-app-btn m-nav-openapp")[0].style.display = "none"; 
      // document.getElementsByClassName("m-navbar")[0].style.display = "none";    
      // document.getElementsByClassName("channel-menu")[0].style.display = "none";    `,
      (ret) => {
      }
    );
};

browserController.prototype.getCurrentURL = function(webview) {
  if(!this.webview || !this.webview.window)return;
  this.webview.evaluateJavaScript(
    `window.location.href`,
    (ret) => {
      this.webview.url = ret
    }
  );
};

browserController.prototype.changeButtonOpacity = function(opacity) {
    this.webAppButton.layer.opacity = opacity
    this.searchButton.layer.opacity = opacity
    this.homeButton.layer.opacity = opacity
    this.goBackButton.layer.opacity = opacity
    this.goForwardButton.layer.opacity = opacity
    this.webAppEntriesButton.layer.opacity = opacity
    this.refreshButton.layer.opacity = opacity
    this.screenButton.layer.opacity = opacity
    this.engineButton.layer.opacity = opacity
    this.moveButton.layer.opacity = opacity
    this.maxButton.layer.opacity = opacity
    this.closeButton.layer.opacity = opacity
}
browserController.prototype.setButtonLayout = function (button,targetAction) {
    button.autoresizingMask = (1 << 0 | 1 << 3);
    button.setTitleColorForState(UIColor.whiteColor(),0);
    button.setTitleColorForState(this.highlightColor, 1);
    button.backgroundColor = UIColor.colorWithHexString("#9bb2d6").colorWithAlphaComponent(0.8);
    button.layer.cornerRadius = 8;
    button.layer.masksToBounds = true;
    if (targetAction) {
      button.addTargetActionForControlEvents(this, targetAction, 1 << 6);
    }
    this.view.addSubview(button);
}
function getSplitLine() {
    let studyFrame = Application.sharedInstance().studyController(this.window).view.bounds
    let readerFrame = Application.sharedInstance().studyController(this.window).readerController.view.frame
    let hidden = Application.sharedInstance().studyController(this.window).readerController.view.hidden//true代表脑图全屏
    let rightMode = Application.sharedInstance().studyController(this.window).rightMapMode
    let fullWindow = readerFrame.width == studyFrame.width
    if (hidden || fullWindow) {
      let splitLine = studyFrame.width*0.5
      return splitLine
    }
    if (rightMode) {
      let splitLine = readerFrame.x+readerFrame.width
      return splitLine
    }else{
      let splitLine = readerFrame.x
      return splitLine
    }
  }